//keyH5.h
//archivo header universal nico
//incluye todas las funciones para manejar
//el convertidor AD, el LCD,las funciones 
//de delay y las funciones del teclado
//para el compilador HITECH
//funciona para EVOLUPIC Bootloader 16F88 
//Cristal = 4 Mhz.
//pero pueden realizarse modificaciones
//para cualquier otro hardware.

/* --------------------------------------------------------------------- */
//en estas 4 lneas se definen cuales
//funciones se usan (DELAY,LCD,TECLADO,ADC)

#define DELAY
#define LCD
#define TECLADO
#define ADC


#define HIDE_CURSOR	0,25
#define bitset(temp, var,bitno) ((temp) |=1 << (bitno));(var)=(temp)
#define bitclr(temp, var,bitno) ((temp) &= ~(1 << (bitno)));(var)=(temp)


void DelayMs(int a);
void InitIO(void);
void ClearScreen(void);
void GotoXY(unsigned char r, unsigned char c);
void PutChar(char c);
void PrintString(const char* s);
void EnableLCD(void);
void EnableLCD2(void);
unsigned char GetBot(void);
void WrtBot(void);
void SetBot(void);
void fin(void);
void row(void);
unsigned long int CANAL3ADC(void);

/*-------------------------------------------------------------------------*/
#ifdef DELAY
void DelayMs(int a)
{
while(a)
	{
	_delay(1000);	//_delay() es una funcin integrada a libreras del
	a--;		//compilador HiTech. El parmetro en microsegundos
	}
}
#endif DELAY
/*-------------------------------------------------------------------------*/


          
/*-------------------------------------------------------------------------*/
#ifdef LCD
#define DATA_BUS PORTB
#define RS       RA1 
#define E        RA2
#define RS_BIT   1
#define E_BIT    2

/*-------------------------------------------------------------------------*/

unsigned char tempA = 0x00;

/*-------------------------------------------------------------------------*/

void EnableLCD(void) {

    bitclr(tempA, PORTA, RS_BIT); _delay(50); //RS = 0
    bitset(tempA, PORTA, E_BIT); _delay(50);  //E = 1
    bitclr(tempA, PORTA, E_BIT); _delay(50);  //E = 0
}

/*-------------------------------------------------------------------------*/

void EnableLCD2(void) {

    bitset(tempA, PORTA, RS_BIT); _delay(50);
    bitset(tempA, PORTA, E_BIT);  _delay(50);
    bitclr(tempA, PORTA, E_BIT);  _delay(50);

}

/*-------------------------------------------------------------------------*/

void InitIO(void) {

    DATA_BUS=0x38; EnableLCD(); DelayMs(5);
    DATA_BUS=0x38; EnableLCD(); _delay(100);
    DATA_BUS=0x38; EnableLCD(); _delay(100);
    DATA_BUS=0x38; EnableLCD(); _delay(100);

    DATA_BUS=0x01; EnableLCD(); DelayMs(50);
    DATA_BUS=0x0d; EnableLCD(); _delay(100);
    DATA_BUS=0x06; EnableLCD(); _delay(100);
}

/*-------------------------------------------------------------------------*/

void ClearScreen(void) {

    DATA_BUS=0x01; 
	EnableLCD();               
	DelayMs(10);
}

/*-------------------------------------------------------------------------*/

void GotoXY(unsigned char r, unsigned char c) {

    DATA_BUS=0x02; EnableLCD();               
	DelayMs(10);
    for(r=r*40+c, c=0; c<r; c++) {
        DATA_BUS = 0x14;
	    EnableLCD(); 
		_delay(100);
    }
}

/*-------------------------------------------------------------------------*/

void PutChar(char c) {

    DATA_BUS = c; EnableLCD2(); _delay(40);
}

/*-------------------------------------------------------------------------*/

void PrintString(const char* s) {

    while( *s ) PutChar(*(s++));
}

#endif LCD

#ifdef TECLADO
char key[16] = {0xEE,0xED,0XEB,0XE7,0XDE,0XDD,0XDB,0XD7,0XBE,0XBD,0XBB,0XB7,0X7E,0X7D,0X7B,0X77};
char asc[16] = {0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x41,0x42,0x43,0x44,0x45,0x46};
unsigned char aa,bb,cc,dd,ee,ff,xx,yy,zz,boton;
char bot[9];


unsigned char GetBot(void)			//la variable de salida se define como unsigned char
{
loop:
	ee=0;
	TRISA=0x18;				/*PUERTO A:RA0,RA1,RA2 SALIDAS; RA3,RA4 ENTRADAS*/
	TRISB=0XF0;
	RBPU=0;					//REGISTRO OPTION, BIT7
							//SELECCIONA RESISTENCIAS DE PULL UP
	PORTA=0;					/*PUERTO B RB0..RB3 SALIDAS, RB4..RB7*/
	aa=0xEF;
	PORTB=aa;
	bb=4;
	while (bb>0) 			/*4 corrimientos hacia la derecha*/
	{aa=aa/2;
	PORTB=aa;				/*ESCRIBE EN PORTB RB0..RB3*/
							/*LEE PUERTO  RB4..RB7*/
	DelayMs(5);		
	if (RB4==0||RB5==0||RB6==0||RB7==0)fin();
	if (ee==1)return (ff);		/*regresa a main con el valor de la tecla en ASCII*/
	bb=bb-1;}
	goto loop;

}
void fin(void){			/*tecla oprimida*/
	
	TRISB=0XF0;
	dd=PORTB;
	cc=(dd & 0XF0);		/*bits RB0..RB3 =0, conserva RB4..RB7*/
	aa=(aa & 0x0F);		/*bits RB4..RB7 =0, conserva RB0..RB3*/
	aa=(aa | cc);			/*la variable "a" contiene el cdigo rengn columna de la tecla oprimida*/

malla:	
	dd=PORTB;			
	cc=(dd & 0XF0);			/*bits RB0..RB3 =0, conserva RB4..RB7*/
	if(cc!=0xF0)goto malla; 	/*espera que la tecla se libere*/
	TRISB=0;
	row();	
	ff=xx;			/*convierte a cdigo ASCII*/
	ee=1;
}				
 	void row(void)
	{

	for(yy=0;yy<16;yy=yy+1)
	{if (aa==key[yy])xx=asc[yy];}	/*la variable "x" contiene el valor ASCII*/
	PORTB=xx;
	DelayMs(100);
}

void SetBot(void)
{
for(zz=0;zz<7;zz++)
{boton=GetBot();
bot[zz]=boton;
if(bot[zz]==0x46)goto qu;
else PutChar(boton);}
qu:bot[zz]=0x00;
}

void WrtBot(void)
{
for(zz=0;zz<7;zz++)
{PutChar(bot[zz]);
if(bot[zz+1]==0)goto ka;}
ka:zz=zz;				//expresin dummy
}
	
#endif TECLADO	
	
#ifdef ADC

//-------FUNCION CONVERSION ADC, CANAL 3, PIN RA3, 0 A 5 VOLTS.
//REGRESA CON EL VALOR DE LA CONVERSION EN 10 BITS

unsigned long int CANAL3ADC(void)
{
unsigned long int adc;
TRISA=0XF8;
TRISB=0;
ANSEL=8;
ADCON1=0;
ADFM=1;
CHS0=1;
CHS1=1;
CHS2=0;
ADCS0=0;
ADCS1=0;
ADON=1;
GODONE=1;			//PREPARA CONVERSION
ESPERA:
if(GODONE==1)goto ESPERA;	//ESPERA FIN DE CONVERSION
adc=ADRESL+(256*ADRESH);
return(adc);
}

#endif ADC